%% --------------------------------------------------------------------------------------------------
% vb_script - script to run inference and model comparison
%
%---------------------------------------------------------------------------------------------
% INPUT: 
%       demono - 1 for inference ,2 for model selection
%      
%
% Optional:
%
%--------------------------------------------------------------------------------------------
% OUTPUT: 
%
% -------------------------------------------------------------------------------------------
% REFERENCE:
%
% Author:
%     Sudhir Shankar Raman , Nov 2015 
%

%%
function vb_script(demono)

demo1();

if(demono>1)
    demo2();
end

function demo1()
[data,params] = simulate_glm();

[result] = invert_glm_vb(data,params);

figure;
subplot(3,1,1);plot(result.Ftrace);title('Free Energy Trace');
subplot(3,1,2);bar([params.exact.mu result.q.mu]);title('Parameter estimate comparison');
subplot(3,1,3);bar([params.exact.logevidence result.F]);
title('True vs estimated Log evidence');


function demo2()
[data,params] = simulate_glm();


% Model 1
[result1] = invert_glm_vb(data,params);

%Model 2
[N,D] = size(data.x);
data1 = data;
data1.x = zeros(N,D);
data1.x(:,2) = ones(N,1);
[result2] = invert_glm_vb(data1,params);


% Model 3
params.prior.tau = 10;
[result3] = invert_glm_vb(data,params);


% Model 4
params.prior.tau = 0.001;
[result4] = invert_glm_vb(data,params);

figure;
subplot(2,1,1);
bar([result1.F result2.F result3.F result4.F]);
title('Model Comparison');

subplot(2,1,2);
bar([0 result1.F-result2.F result1.F-result3.F result1.F-result4.F]);
title('Model Comparison');
hold on;plot([0.5,4.5],[3 3],'LineWidth',3,'Color','r')

